#include <owl\applicat.h>
#include <owl\framewin.h>
#include <owl\dialog.h>
#include <owl\scroller.h>
#include <owl\edit.h>
#include <owl\dc.h>
#include "pr50_1.rc"

//  .
struct
{
  char unitsEdit[3];
  char lineEdit[3];
  char hRangeEdit[4];
  char vRangeEdit[4]; 
} transBuf;
//     .
struct rec
{
  int color;
  int x;
  int y;
};

// .
class TApp: public TApplication
{
  public:
	 TApp():TApplication() {}
	 void InitMainWindow();
};

//   .
class TWndw : public  TFrameWindow
{
  public:
	 TWndw (TWindow *parent, const char far *title);
  protected:
         rec  recArray[100];
         void Paint(TDC &dc, BOOL, TRect&); 
         void CmSetScroll(); 
         void SetScroller();

	 DECLARE_RESPONSE_TABLE (TWndw);
};

DEFINE_RESPONSE_TABLE1 (TWndw, TFrameWindow)
	EV_COMMAND (CM_SETSCROLL, CmSetScroll),
END_RESPONSE_TABLE;

//   Scroll Values.
class TDlg : public TDialog
{
  public:
	 TDlg(TWindow *parent, TResId resId);
};

// TWndw::TWndw()
//    .
TWndw::TWndw(TWindow *parent, const char far *title):
			 TFrameWindow (parent, title)
{
  //     
  //    .
  Attr.Style |= WS_VSCROLL | WS_HSCROLL;
  //     .
  Attr.X = 20;
  Attr.Y = 20;
  Attr.W = 400;
  Attr.H = 300;
  //  OWL-   .
  Scroller = new TScroller (this, 1, 1, 640, 480);
  //    .
  AssignMenu(MENU_1);
  //    ,
  //    100  .
  randomize();
  for (int i = 0; i < 100; ++i)
  {
    recArray[i].color = random(16); 
    recArray[i].x = random(619); 
    recArray[i].y = random(459);
  }
}

// TWndw::Paint()
//  ,   
// Paint()  TWindow,   
// WM_PAINT,   Windows ,
//    .
void TWndw::Paint (TDC& dc, BOOL, TRect&)
{
  //  100 . 
  for (int i = 0; i < 100; ++i)
  {
    //     
    //  .
    TBrush *brush = new TBrush (recArray[i].color);
    //      . 
    dc.SelectObject (*brush);
    //  .
    dc.Rectangle (recArray[i].x, recArray[i].y,
           recArray[i].x + 20, recArray[i].y + 20);
    //    . 
    delete brush;
  }
}

// TWndw::CmSetScroll()
//      CM_SETSCROLL,
//  ,  
//   SetScroller   Scroller.
void TWndw::CmSetScroll() 
{
  //    ScrollValues.
  TDialog *dialog = new TDlg(this, SCROLLDLG);
  //     
  //     ScrollValues.
  char s[10];
  itoa(Scroller->XUnit, s, 10); 
  strcpy(transBuf.unitsEdit, s); 
  itoa(Scroller->XLine, s, 10); 
  strcpy(transBuf.lineEdit, s); 
  itoa(Scroller->XRange, s, 10); 
  strcpy(transBuf.hRangeEdit, s); 
  itoa(Scroller->YRange, s, 10); 
  strcpy(transBuf.vRangeEdit, s);
  //   . 
  int result = dialog->Execute();
  //        
  //  ,    . 
  if (result == IDOK)
    SetScroller();
}

// TWndw::SetScroller()
//     TScroller ,
//      Scroll Values.
void TWndw::SetScroller()
{
  //    XUnit  YUnit.
  int units = atoi (transBuf.unitsEdit);
  if (units > 0) Scroller->SetUnits(units,units);
  //    XLine  YLine.
  int line = atoi (transBuf.lineEdit);
  if (line > 0) 
  {
    Scroller->XLine = line;
    Scroller->YLine = line;
  }
  //    .
  long hRange = atoi (transBuf.hRangeEdit);
  long vRange = atoi (transBuf.vRangeEdit);
  //    .
  Scroller->SetRange(hRange, vRange);
}

//**************************************
//   TDlg.
//**************************************
// TDlg::TDlg()
//     ScrollValues.
TDlg::TDlg(TWindow *parent, TResId resId): TDialog (parent, resId)
{
  //  OWL- TEDIT    
  //   .
  new TEdit(this, ID_UNITS, sizeof(transBuf.unitsEdit));
  new TEdit(this, ID_LINE, sizeof(transBuf.lineEdit));
  new TEdit(this, ID_HRANGE, sizeof(transBuf.hRangeEdit));
  new TEdit(this, ID_VRANGE, sizeof(transBuf.vRangeEdit));
  //    .
  TransferBuffer = &transBuf;
}

void TApp::InitMainWindow()
{
  TFrameWindow *wndw = new TWndw (0," ");
  SetMainWindow(wndw);
}

int OwlMain(int,char *[])
{
  return TApp().Run();
}
